#include <stdio.h>
#include <signal.h>
#include <sys/malloc.h>
#include <ctype.h>
#include <string.h>

#if defined(SYSV) || defined(DOS)
#  include <stdlib.h>
#  define index   strchr
#else
#  include <strings.h>
/*  typedef unsigned size_t; */
#  define SEEK_SET 0
#  define SEEK_CUR 1
#  define SEEK_END 2
#endif

#if !defined(SYSV) || defined(DOS)
#  define EXIT_FAILURE 1
#  define EXIT_SUCCESS 0
#endif

#define TRUE               1
#define FALSE              0
#define EOT           '\004'
#define PROG_NAME  "ps2eps"
#define VERSION    "version 1.0"
#define MAXBUF	         256
#define MAXFILE           40
#define MAXWORD           40
#define BB_MAXLINE        20
#define MAX_WIDTH        140	/* maximum picture width */
#define MAX_HEIGHT       200	/* maximum picture height */
#define DP_OFFSET         10	/* offset for DrawPerfect in mm */
#define GEM_OFFSET         3	/* offset for GEM in mm */
#define TOP_SPACE          6	/* space in pt between character bottom
				   and top of boundingbox. */
#define MAXTOKENS         25
#define PRINTGL_RES     1016	/* PrintGL resolution 1016 pt/inch  */
#define POSTSCRIPT_RES    72	/* PostScript resolution 72 pt/inch */

#define SEP_CHARS		" \012"		/* PrintGL PostScript */
#define MOVE_TO			"MT"		/* PrintGL PostScript */
#define LINE_TO			"DT"		/* PrintGL PostScript */

#define FIRSTLINE		"%!PS-Adobe-2.0 EPSF-2.0\n"
#define BB_BUF "%                                                        "
#define BEGINUSERDICT		"userdict"
#define ENDUSERDICT		"GEM_INIDOC"
#define INITCLIP		"initclip"
#define LANDSCAPE		"landscape{p1"
#define PPBOUNDINGBOX		"%%BoundingBox"
#define PPBOUNDINGBOXC		"%%BoundingBox:"
#define PPENDPROLOG		"%%EndProlog"
#define PPPAGE			"%%Page"
#define PPPAGES			"%%Pages"
#define ATEND			"(atend)"
#define PPENDCOMMENTS		"%%EndComments"
#define PPBEGINEXITSERVER	"%%BeginExitServer"
#define PPEOF			"%%EOF\n"
#define PPENDPROLOG		"%%EndProlog"
#define SHOWPAGE		"showpage"
#define TRANSLATE		"translate"
#define SCALE			"scale"
#define ROTATE			"rotate"
#define CURRENTPOINT		"currentpoint"
#define EPS			"eps"
#define DEPS			".eps"
#define MOVETO			"moveto"
#define LINETO			"lineto"
#define NEWPATH			"newpath"
#define STROKE 			"stroke"
#define PPPAGESIZE		"%%PageSize"
#define PPPAGEBOUNDINGBOX	"%%PageBoundingBox"
#define PPFEATURE		"%%Feature"
#define GSAVE			"gsave"
#define DVIALW_BEGIN		"%begin(plot)\n"
#define DVIALW_END		"%end(plot)\n"
#define PPP			"%%%"
#define Ba4                     "{a4"
#define Ba4BSTOPPED             "{a4}stopped"

/*
** In the PS file from PSpice there is no BoundingBox statement.
** The boundingbox dimensions always are that of an A4 page in
** landscape position.
** The picture is transformed to default dimensions in portrait
** position by commenting out the 'rotate' and 'translate' statements
** in the PSpice PS file and inserting a scale statement.
** The initial boundingbox values below are in points.
*/
#define PSPICE_BBOX_LLX    6.6
#define PSPICE_BBOX_URX  146.0
#define PSPICE_BBOX_LLY    1.7
#define PSPICE_BBOX_URY  115.0
#define PSPICE_SCX         0.55
#define PSPICE_SCY         0.55

#define READc(c)   {gets(buf); sscanf(buf,"%1s",c);}
